package com.nisum.example.client;

import com.nisum.example.model.Person;

import java.util.*;
import java.util.stream.Collectors;

/**
 * Main class for setting object data and getting results
 */
public class ClientApp {
    public static void main(String[] args) {
        Person p1= new Person(1201,"HARI",8700,"HYD","DEV",20200725122530L,
                Arrays.asList("7722448815","9966778844","9944668877"));
        Person p2= new Person
                (1202,"SHAM",5500,"PUNE","QA",
                        20201025013020L, Arrays.asList("8855447788","7547871478","0147248784"));
        Person p3= new Person
                (1203,"SAI",7500,"BANGLORE","DEV",
                        20200825032515L, Arrays.asList("7755447788","6767714785","01452487845"));
        Person p4= new Person
                (1204,"KIRAN",9500,"CHENNAI","DEV",
                        20201125052010L, Arrays.asList("8855447788","7667714785","01252487845"));
        Person p5= new Person
                (1203,"KHAN",4500,"CHENNAI","PROD",
                        20200625072045L, Arrays.asList("9955447788","1467714785","02352487845"));

        List<Person> personList=Arrays.asList(p1,p2,p3,p4,p5);

        // find the person id with highest salary in a given department
      Optional<Person> highestPaidPersonWrapper=  personList.stream()
              .filter(p-> p.getDepartment().equals("DEV")
              ).collect(Collectors.maxBy(Comparator.comparingInt(f-> f.getSalary())));

      System.out.println("Highest Salary Person ID: "+highestPaidPersonWrapper.get().getId());

      //print the no of employees at each location.
        Map<String,Long> personCountByLocation=personList.stream()
                .collect(Collectors.groupingBy(Person::getLocation,Collectors.counting()));

        Set<Map.Entry<String,Long>> entrySet=personCountByLocation.entrySet();
        for(Map.Entry<String,Long> entry:entrySet){
            System.out.println(entry.getKey()+" "+entry.getValue());
        }

        //verify the two persons provided the same phone number

        //sort the person list based on timestamp.
        //sort descending
       List<Person> sortBasedOnTimestamp= personList.stream()
               .sorted(Comparator.comparing(Person::getTimestamp).reversed()).collect(Collectors.toList());
       sortBasedOnTimestamp.forEach(System.out::println);




    }
}
