package com.nisum.example.client;

import com.nisum.example.model.Employee;

import java.util.Arrays;
import java.util.List;
import java.util.Optional;
import java.util.OptionalInt;

public class EmployeeTest {
    public static void main(String[] args) {
        List<Employee> employeeList= Arrays.asList(new Employee("MARY",25
                        ,Arrays.asList("8877445511","3355778845"))
        ,new Employee("KHAN",30,Arrays.asList("8877445587","3355778887")),
                new Employee("SYED",26,Arrays.asList("8877445531","3355778887")));

        //Given a list of employees, you need to filter all the employee whose age is greater
        // than 20 and print the employee names.(Java 8 APIs only)
        employeeList.stream().filter(f-> f.getAge()>20)
                .map(f-> f.getName())
                .forEach(c-> System.out.println(c));

        //Given the list of employees, count number of employees with age 25?
       Long count= employeeList.stream().filter(f-> f.getAge()>25).count();
       System.out.println(count);

       //Given the list of employees, find the employee with name “Mary”.
      Optional<Employee> optionalEmployee= employeeList.stream().filter(f-> f.getName().equalsIgnoreCase("mary"))
                .findAny();
      optionalEmployee.ifPresent(c-> System.out.println(c));

      //Given a list of employee, find maximum age of employee?
     OptionalInt intOptional=   employeeList.stream().mapToInt(Employee::getAge)
                .max();
     if (intOptional.isPresent()){
         System.out.println(intOptional.getAsInt());
     }

     //Given a list of employees, sort all the employee on the basis of age? Use java 8 APIs only
        employeeList.sort((e1,e2)->e1.getAge()-e2.getAge());
     employeeList.forEach(System.out::println);

     //----------------------------------------------------------------
        System.out.println("----------------");
        //to collect names of all employees
        employeeList.stream().map(person -> person.getName()).forEach(System.out::println);

        //collect all phone numbers
        employeeList.stream().flatMap(person-> person.getPhoneNumbers().stream())
                .forEach(System.out::println);


    }
}
